# DocBlockr Extended Changelog

- **v2.10.0**, *21 February 2013*
  - Adds Sublime Text 3 support (thanks to @lxe and @rmarscher)
  - YUI-style `@method` tags can be automatically added with the `jsdocs_autoadd_method_tag` setting (thanks to @maheshjag)
  - Variables starting with `$` are not wiped out when reparsing a doc block (thanks @ryrun)
- **v2.9.3**, *12 December 2012*
  - Fixed bug which stopped regular comments from closing automatically
- **v2.9.2**, *11 December 2012*
  - This one goes out to [Thanasis Polychronakis](https://github.com/thanpolas).
    - Structure of the modules greatly improved
    - Fixes bug with matching languages with hyphens in the name
  - Adds support for CUDA-C++
- **v2.9.1**, *31 October 2012*
  - Thanks to [wronex](https://github.com/wronex), <kbd>Alt+Q</kbd> will reformat the entire DocBlock, with customisable indentation.
  - Thanks to [Pavel Voronin](https://github.com/pavel-voronin), spaces around arguments are handled properly.
  - **C/C++**: Array arguments are accepted
  - **C/C++**: An argument list containing only `void` doesn't output any `@param` tags
  - **PHP**: Arguments with an array as a default value inside multi-line arguments are handled properly
  - <kbd>Ctrl/Cmd + Enter</kbd> and <kbd>Ctrl/Cmd + Shift + Enter</kbd> work inside DocBlocks.
- **v2.9.0**, *1 October 2012*
  - Adds ObjectiveC and ObjectiveC++ support, thanks to some help from [Robb Böhnke](https://github.com/robb)
    - Very buggy code, support isn't great but it's better than nothing (hopefully).
  - Single-line comments inside function definitions are handled
  - Notation rules are applied to functions, which means they can define a return type by their name, eg: `strFoo`
  - Notation rules can define arbitrary tags, for example: functions with a prefix of "_" should get the `@private` tag.
  - Given the above addition, JS functions starting with an underscore are no longer marked as `@private` by default.
- **v2.8.2**, *28 September 2012*
  - When a function is defined across many lines, the parser will find the arguments on extra lines.
- **v2.8.1**, *13 September 2012*
  - Pressing <kbd>tab</kbd> on an empty line will perform a deep indentation instead of moving to the next field
  - Functions starting with `_` will get a `@private` tag in Javascript (thanks to [Andrew Hanna](https://github.com/percyhanna))
- **v2.8.0**, *26 August 2012*
  - New feature: <kbd>Alt+Q</kbd> to reformat the description field of a docblock to make it fit nicely within your ruler.
  - Adds support for C++ (thanks to [Rafał Chłodnicki](https://github.com/rchl))
  - Indenting to the description field works in languages which don't require type information in the docblock.
- **v2.7.4**, *8 August 2012*
  - Fix for Actionscript docblocks not working
- **v2.7.3**, *7 August 2012*
  - No trailing whitespace added on the spacer lines added when `jsdocs_spacer_between_sections` is on (thanks to [Rafał Chłodnicki](https://github.com/rchl))
  - Fixes a bug with detecting variable names when they have a default value in PHP
  - Changes the notation map to not ignore the leading `$` or `_`, meaning that (for example), you could specify that variables starting with `$` are `HTMLElement`s.
- **v2.7.2**, *6 August 2012*
  - Small bug fix, thanks to [djuliusl](https://github.com/djuliusl)
- **v2.7.1**, *5 August 2012*
  - Adds per-section alignment (can be set using `jsdocs_per_section_indent`)
  - Description field for `@return` tag can be disabled using `jsdocs_return_description`. *(Both thanks to [Drarok](https://github.com/Drarok))* 
- **v2.7.0**, *5 August 2012*
  - Adds support for ASDocs (Actionscript)
  - Changes Linux shortcut for reparsing a comment block to <kbd>Alt+Shift+Tab</kbd>
- **v2.6.5**, *19 June 2012*
  - Bugfix for adding linebreaks when not at the start or end of a line
- **v2.6.4**, *4 June 2012*
  - Better support for indentation using tabs
  - YUI tags are supported by the autocomplete
  - When only whitespace exists on a docblock line, and `trim_automatic_white_space` is set to true, the whitespace is removed.
  - Better support for comment blocks opened with `/*`
- **v2.6.3**, *30 April 2012*
  - Fixes the join-lines command <kbd>Ctrl+J</kbd> for CoffeeScript.
- **v2.6.2**, *22 March 2012*
  - PHP `__destruct` functions don't get a return value *(thanks to [Alex Whitman](https://github.com/whitman))*.
- **v2.6.1**, *16 March 2012*
  - Fixes bug whereby the return values of functions which are named `set` or `add`, *etc* were not being guessed correctly.
  - `@return` tags are now given a description field *(thanks to [Nick Dowdell](https://github.com/mikulad13))*.
- **v2.6.0**, *4 March 2012*
  - Added CoffeeScript support
- **v2.5.0**, *11 February 2012*
  - Implemented DocBlock reparsing to re-enable tabstop fields. Hotkey is `Ctrl+Alt+Tab`.
- **v2.4.1**, *2 February 2012*
  - Fixed bug [#36](https://github.com/spadgos/sublime-jsdocs/issues/36) whereby docblocks were not being properly extended inside of `<script>` tags in a HTML document.
- **v2.4.0**, *29 January 2012*
  - `Enter` at the end of a comment block (ie: after the closing `*/`) will insert a newline and de-indent by one space.
- **v2.3.0**, *15 January 2012*
  - `Ctrl+Enter` on a double-slash comment will now decorate that comment.
  - Added a setting (`jsdocs_spacer_between_sections`) to add spacer lines between sections of a docblock.
- **v2.2.2**, *12 January 2012*
  - Separated JS and PHP completions files. PHP completions don't have brackets around type information any more.
  - PHP now uses `@var` (instead of `@type`) for documenting variable declarations.
  - *Both of these changes are thanks to [svenax][svenax]*
- **v2.2.1**, *11 January 2012*
  - DocBlocks can be triggered by pressing `tab` after `/**`
  - Some bugfixes due to auto-complete changes in Sublime Text.
  - Fixed bug where indenting would not work on the first line of a comment.
- **v2.2.0**, *5 January 2012*
  - A configuration option can be set so that either `@return` or `@returns` is used in your documentation. 
  - Language-specific tags now will only show for that language (eg: PHP has no `@interface` tag).
- **v2.1.3**, *31 December 2011*
  - Changed path for macro file to point to `Packages/DocBlockr`. If you are having issues, make sure that the plugin is installed in that location (**not** the previous location `Packages/JSDocs`).
- **v2.1.2**, *31 December 2011*
  - Renamed from *JSDocs* to *DocBlockr*, since it now does more than just Javascript.
- **v2.1.1**, *23 November 2011*
  - Fixed bug which broke the completions list
- **v2.1.0**, *19 November 2011*
  - Added a command to join lines inside a docblock which is smart to leading asterisks
  - Variable types are guessed from their name. `is` and `has` are assumed to be Booleans, and `callback`, `cb`, `done`, `fn` and `next` are assumed to be Functions.
  - You can now define your own patterns for mapping a variable name to a type.
  - Autocomplete works better now. `@` will also insert the "@" character, allowing you to add any tag you like, even if it isn't in the autocomplete list.
  - Added the full set of [PHPDoc][phpdoc] tags.
- **v2.0.0**, *6 November 2011*
  - PHP support added!
  - (Almost) complete rewrite to allow for any new languages to be added easily
    - *Please send feature requests or pull requests for new languages you'd like to add*
  - More options for aligning tags
- **v1.3.0**, *5 November 2011*
  - Improvements to handling of single-line comments
  - Functions beginning with `is` or `has` are assumed to return Booleans
  - Consolidated settings files into `Base File.sublime-settings`. **If you had configured your settings in `jsdocs.sublime-settings`, please move them to the Base File settings.**
  - Setting `jsdocs_extend_double_slashes` controls whether single-line comments are extended.
  - Pressing `tab` in a docblock will tab to match the description block of the previous tag. Use `jsdocs_deep_indent` to toggle this behaviour.
- **v1.2.0**, *6 October 2011*
  - Variable declarations can be documented. `Shift+enter` to make these inline
  - Double slash comments (`// like this`) are extended when `enter` is pressed
  - Class definitions detected and treated slightly differently (no return values pre-filled)
- **v1.1.0**, *3 October 2011*
  - DocBlockr parses the line following the comment to automatically prefill some documentation for you.
  - Settings available via menu
- **v1.0.0**, *28 September 2011*
  - Initial release
  - Comments are automatically closed, extended and indented.
